close all
clear all
mu = [-7,7,-7].';
mu = mu/norm(mu);
mu_1 = (eye(3)-mu*(mu.'))*([1,0,0].');
mu_1 = mu_1/norm(mu_1);
mu_2 = (eye(3)-mu*(mu.'))*([0,1,0].');
mu_2 = mu_2/norm(mu_2);
mu_2 = mu_2 - mu_2.'*mu_1*mu_1;
mu_2 = mu_2/norm(mu_2);
r = 10;
R = 5*[5,5,5].';
R_len = norm(R);
R_hat = R/R_len;
lam = 0.2;
dy = lam/4; dz = dy;
a = 0;
my_number = 100;
mz_number = 100;
my_total = -my_number:1:my_number;
mz_total = -mz_number:1:mz_number;
Rela = zeros(2*mz_number+1,2*my_number+1);
my = 0*Rela; mz = 0*Rela; 
ny = ones(2*mz_number+1,1)*my_total;
nz = mz_total'*ones(1,2*my_number+1);
Rela = Rela+correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu);   %cluster one
R = 5*[5,-5,10].';
a = 2;
r = 6;
mu = [-7,-7,-7].';
mu = mu/norm(mu);
Rela = Rela+correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu);   % cluster two
R = 5*[5,-5,-10].';
a = -0.8;
r = 6;
mu = [-7,-7,-7].';
mu = mu/norm(mu);
Rela = Rela+correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu);    %cluster three
figure  
[x,y]=meshgrid(my_total,mz_total);
H1=mesh(x,y,abs(Rela));
shading interp; 
%colorbar
xlabel('y axis','Interpreter','latex','FontSize',12,'Rotation',-15);
ylabel('z axis','Interpreter','latex','FontSize',12,'Rotation',30);
zlabel('Correlation function','Interpreter','latex','FontSize',12);
%axis equal
figure
% K1_temp = dftmtx(2*mz_number+1);
% K2_temp = dftmtx(2*nz_number+1);
% K1 = K1_temp;
% K2 = K2_temp;
% K1(:,1:mz_number) = K1_temp(:,mz_number+2:end);
% K1(:,mz_number+1:end) = K1_temp(:,1:mz_number+1);
% K2(:,1:mz_number) = K2_temp(:,mz_number+2:end);
% K2(:,mz_number+1:end) = K2_temp(:,1:mz_number+1);
K1 = DFTmatrix(lam,mz_total,dz);
K2 = DFTmatrix(lam,my_total,dz);
DFT_Rela = K1*Rela*K2';
pcolor(x/100,y/100,-abs(DFT_Rela));
colormap gray
shading interp; 
%colorbar
axis equal
xlabel('wavenumber $\kappa_y/\kappa$','Interpreter','latex','FontSize',14);
ylabel('z axis','Interpreter','latex','FontSize',12,'Rotation',30);
zlabel('Correlation function','Interpreter','latex','FontSize',12);
%axis equal