close all
clear all
load('rela_d.mat');
global Rela_cdl_d;
global lam;
global dy; global dz;
global my_number;
global mz_number;
global save_fval;
save_fval = [];
Rela_cdl_d = Rela_cdl;
lam = 0.2;
dy = lam/8; dz = dy;
my_number = 50;
mz_number = 50;
my_total = -my_number:1:my_number;
mz_total = -mz_number:1:mz_number;
Rela = zeros(2*mz_number+1,2*my_number+1);
my = 0*Rela; mz = 0*Rela; 
ny = ones(2*mz_number+1,1)*my_total;
nz = mz_total'*ones(1,2*my_number+1);
options = optimoptions(@fminunc,'Display','iter','Algorithm','quasi-newton','OutputFcn',@outfun);
%x0 = [0.5,1,0,-1,1,1,-7,7,-7;0.1,1,0,1,-0.8,4,-7,7,-7;0,10,0,5,-0.8,4,7,7,-7];   
x0 = [1,30,0,-5,1,1,-7,7,-7;1,30,0,5,-0.8,4,-7,7,-7;0,10,0,5,-0.8,4,7,7,-7];
[x_out,fval,exitflag,output] = fminunc(@myfun,x0,options)
%global Rela_temp1 
Rela = myfun_rela(x_out);
% Rela_temp1 = Rela;
% x0 = [0.01,60,40,-8,-0.8,10,-7,-7,-7;0.01,5,-10,40,-0.8,10,-7,-7,-7;0.01,10,0,5,-0.8,4,7,7,-7;1,30,0,-5,1,1,-7,7,-7];
% [x_out1,fval,exitflag,output] = fminunc(@myfun1,x0,options)
% Rela1 = myfun_rela(x_out1);
% Rela_total = Rela+Rela1;
% Rela = Rela_total;
%Rela = myfun_rela(x);

% P1_total = 0.5:0.05:1.5;
% P2_total = 0.5:0.05:1.5;
% rela_error = zeros(length(P1_total),length(P2_total));
% for i = 1:length(P1_total)
%     disp(i)
%     for j = 1:length(P2_total)
%         P1 = P1_total(i);
%         P2 = P2_total(j);
% Rela = zeros(2*mz_number+1,2*my_number+1);
% mu = [-7,7,-7].';
% mu = mu/norm(mu);
% mu_1 = (eye(3)-mu*(mu.'))*([1,0,0].');
% mu_1 = mu_1/norm(mu_1);
% mu_2 = (eye(3)-mu*(mu.'))*([0,1,0].');
% mu_2 = mu_2/norm(mu_2);
% mu_2 = mu_2 - mu_2.'*mu_1*mu_1;
% mu_2 = mu_2/norm(mu_2);
% r = 1;
% R = 5*[6,0,-1].';
% R_len = norm(R);
% R_hat = R/R_len;
% a = 1;
% Rela = Rela+P1*correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu);
% R = 5*[6,0,1].';
% a = 1;
% r = 1;
% mu = [-7,7,-7].';
% mu = mu/norm(mu);
% Rela = Rela+P2*correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu);
% R = 5*[5,-10,40].';
% a = -0.8;
% r = 4;
% mu = [-7,-7,-7].';
% mu = mu/norm(mu);
% %Rela = Rela+correlation_generator(my,mz,ny,nz,dy,dz,R,lam,a,r,mu);
% rela_error(i,j)=sum(sum(real(Rela-Rela_cdl*1000).^2))/sum(sum(real(Rela).^2));
%     end
% end

figure
[x,y]=meshgrid(my_total,mz_total);
pcolor(x,y,abs(Rela_cdl_d*1000));
shading interp; 
%colorbar
axis equal
xlabel('y axis','Interpreter','latex','FontSize',14);
ylabel('z axis','Interpreter','latex','FontSize',14);
axis([-50 50 -50 50]);
temp1=caxis;

figure
[x,y]=meshgrid(my_total,mz_total);
pcolor(x,y,abs(Rela));
shading interp; 
%colorbar
axis equal
xlabel('y axis','Interpreter','latex','FontSize',14);
ylabel('z axis','Interpreter','latex','FontSize',14);
axis([-50 50 -50 50]);
caxis(temp1); 



figure
plot(save_fval,'-s','Linewidth',1.5,'markersize',5);
grid on
xlabel('Iteration number','Interpreter','latex','FontSize',14);
ylabel('$\frac{\| \tilde{\bf R} - {\bf R} \|_{\rm F}^2}{\|{\bf R}\|_{\rm F}^2}$','Interpreter','latex','FontSize',14);
save('save_fval','save_fval');

function [Rela] = myfun_rela(param)
global Rela_cdl_d;
global lam;
global dy; global dz;
global my_number;
global mz_number;
my_total = -my_number:1:my_number;
mz_total = -mz_number:1:mz_number;
Rela = zeros(2*mz_number+1,2*my_number+1);
%Rela = ones(2*mz_number+1,2*my_number+1)*sum(sum(abs(Rela_cdl_d*1000)))/(2*my_number+1)/(2*mz_number+1);
my = 0*Rela; mz = 0*Rela; 
ny = ones(2*mz_number+1,1)*my_total;
nz = mz_total'*ones(1,2*my_number+1);
    Rela = Rela+param(1,1)*correlation_generator(my,mz,ny,nz,dy,dz,param(1,2:4)',lam,param(1,5),param(1,6),param(1,7:9)');
Rela = Rela+param(2,1)*correlation_generator(my,mz,ny,nz,dy,dz,param(2,2:4)',lam,param(2,5),param(2,6),param(2,7:9)');
Rela = Rela+param(3,1)*correlation_generator(my,mz,ny,nz,dy,dz,param(3,2:4)',lam,param(3,5),param(3,6),param(3,7:9)');
end

function stop = outfun(x, optimValues, state)
stop = false;
global save_fval;
i=optimValues.iteration;
save_fval = [save_fval,optimValues.fval];
drawnow
end