function [H,L,error,Rela1] = channel_generator(Rela,n)
    [U,A,V] = svd(Rela);
    L = (U*sqrt(A))';
    Rela1 = L'*L;
    error = 0;
    [l1,l2] = size(Rela);
    for i = 1:l1
        for j = 1:l2
            if(abs(Rela(i,j)-Rela1(i,j))>1e-8)
                error = error+1;
            end
        end
    end
    z = (randn([l1, n]) + 1i*randn([l1, n]))/sqrt(2);   % i.i.d. white noise. 
    %z = randn([l1, n]) ;
    H = L' * z;
end