function [points,DFT_Rela] = cluster_position(H,peak_choice,lam,my_total,mz_total,dy,dz,patio,number_of_cluster)
    [N,~] = size(H);
    my_number = (length(my_total)-1)/2;
    mz_number = (length(mz_total)-1)/2;
    H_reshape = zeros(length(my_total),length(mz_total));
%     for i = 1:length(my_total)
%         H_reshape(i,:) = H((i-1)*length(mz_total)+1:i*length(mz_total));
%     end
    H_reshape = reshape(H, [2*my_number+1, 2*mz_number+1]);
    K1_temp = DFTmatrix(lam,my_total,dy);
    K2_temp = DFTmatrix(lam,mz_total,dz);
    DFT_Rela = abs(K1_temp*H_reshape*K2_temp');
    average = sum(sum(DFT_Rela))/N/patio;
%     light_area_temp = zeros(N,2);
%     counter = 1;
%     for i = 1:l
%         for j=1:l
%             if(DFT_Rela(i,j)>average)
%                 light_area_temp(counter,1) = j;
%                 light_area_temp(counter,2) = i;
%                 counter = counter+1;position_save{iter_par,5} = Rela;
%             end
%         end
%     end
%     light_area = light_area_temp(1:counter-1,:);

%     figure
%     plot(light_area(:,1),light_area(:,2),'.','Markersize',20);
%     figure
%     [x,y]=meshgrid(1:l);
%     pcolor(x,y,abs(DFT_Rela));
% shading interp; 
% %colorbar
% axis equal
% xlabel('wavenumber $\kappa_y$','Interpreter','latex','FontSize',14);
% ylabel('wavenumber $\kappa_z$','Interpreter','latex','FontSize',14);
% [parameter] = GMM_fit(length(mz_total)-1,number_of_cluster,DFT_Rela);
% points = parameter(:,[2,4]);
if(peak_choice==0)
    [locs_y,locs_x] = find(DFT_Rela==max(max(DFT_Rela)));
    %locs_x = 21;
    %locs_y = 21;
else
[pks,locs_y,locs_x] = peaks2(DFT_Rela,'MinPeakHeight',average/3); 
end
points = [locs_x,locs_y];
% figure
% plot(locs_x,locs_y,'.','Markersize',20);
end