function [U,Lam] = compact_eigenvalue_decomposition(Rela,threhold)
    [U,A,V] = svd(Rela);
    [l1,l2] = size(A);
    rank =0;
    for i = 1:l1
        if(A(i,i)>threhold)
            rank = rank+1;
        end
    end
    U = U(:,1:rank);
    Lam = A(1:rank,1:rank);
end