function [Rela] = correlation_generator_vMF(my,mz,ny,nz,dy,dz,lam,mu)
    d_1x = 0*my;
    d_1y = my*dy;
    d_1z = mz*dz;
    d_2y = ny*dy;
    d_2z = nz*dz;
    kappa = 2*pi/lam;
    r = sqrt((d_1x-1i*mu(1)/kappa).^2+(d_1y-d_2y-1i*mu(2)/kappa).^2+(d_1z-d_2z-1i*mu(3)/kappa).^2);
    Rela = sinc(2*r/lam);    
end