function [dftmatrix] = DFTmatrix(lam,mz_total,dz)

    l1 = length(mz_total);
    dftmatrix = zeros(l1,l1);

    r = dz*mz_total;
    kappa = 2*pi/lam;

    kappa_x = -kappa:kappa/(l1-1)*2:kappa;

    for i = 1:l1
        dftmatrix(i,:) = exp(1i*kappa_x(i).*r);
    end

end